(ns wanijo.attribute.domain
  (:require [clojure.spec.alpha :as spec]
            [wanijo.framework.neo4j :as neo4j]))

(spec/def ::name
  (spec/and string? not-empty))

(spec/def ::type
  (spec/and
   string?
   #(some #{"date" "file" "string" "text"} %)))

(spec/def ::required boolean?)

(neo4j/defquery
  findy-by-schema
  "MATCH (a:attribute)-->(s:schema)
   WHERE s.uuid = {uuid}
   RETURN a
   ORDER BY a.name")

(defn find-by-schema! [schema-uuid]
  (->>
   (neo4j/exec-query!
    findy-by-schema
    {:uuid schema-uuid})
   (map :a)))
